
/*******************************************************************************
*
* File check4.c
*
* Copyright (C) 2005 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Checks the SSE instruction cmpps
*
*******************************************************************************/

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <math.h>
#include "su3.h"

#if (defined SSE)

#include "sse.h"

static sse_float x1,x2,x3,one;

int main(void)
{
   x1.c1=1.0f;
   x1.c2=0.0f;
   x1.c3=1.0f;
   x1.c4=0.0f;

   x2.c1=0.0f;
   x2.c2=1.0f;
   x2.c3=1.0f;
   x2.c4=0.0f;

   one.c1=1.0f;
   one.c2=1.0f;
   one.c3=1.0f;
   one.c4=1.0f;

   __asm__ __volatile__ ("movaps %1, %%xmm0 \n\t"
                         "movaps %2, %%xmm1 \n\t"
                         "cmpps $0x6, %%xmm0, %%xmm1 \n\t"
                         "andps %3, %%xmm1 \n\t"
                         "movaps %%xmm1, %0"
                         :
                         "=m" (x3)
                         :
                         "m" (x1),
                         "m" (x2),
                         "m" (one));

   printf("\n");
   printf("Test of the SSE cmpps instruction (imm8=6)\n\n");
   printf("x1<x2 -> x2\n\n");
   printf("x1    = %8.1f,%8.1f,%8.1f,%8.1f\n",x1.c1,x1.c2,x1.c3,x1.c4);
   printf("x2    = %8.1f,%8.1f,%8.1f,%8.1f\n",x2.c1,x2.c2,x2.c3,x2.c4);
   printf("x1<x2 = %8.1f,%8.1f,%8.1f,%8.1f\n",x3.c1,x3.c2,x3.c3,x3.c4);
   printf("\n");

   exit(0);
}

#else

int main(void)
{
   printf("\n");
   printf("Test of the SSE cmpps instruction (imm8=6)\n\n");

   printf("SSE must be enabled for this test\n\n");
   exit(0);
}

#endif
